<?php 
// add the admin options page
add_action('admin_menu', 'awdcsv_admin_add_page');
function awdcsv_admin_add_page() {
add_options_page('AWD Datafeedr CSV Import', 'AWD Datafeedr CSV Import', 'manage_options', 'awdcsv', 'awdcsv_options_page');
}
// display the admin options page
function awdcsv_options_page() {
	?>
	<div>
	<h2>AWD Datafeedr CSV Import Plugin</h2>
	<p>Choose the CSV file you wish to use to add additional products to your Datafeedr store. Please enter a URL for the CSV file - this allows you to modify the CSV file by uploading it to the same location and it will automatically be picked up the next time the Datefeedr import runs.</p>
	

	<form action="options.php" method="post">
	<?php settings_fields('awdcsv_options'); ?>
	<?php do_settings_sections('awdcsv'); ?>
	 
	<input name="Submit" type="submit" value="<?php esc_attr_e('Save Changes'); ?>" />
	</form></div>
	 
	<?php
}

// add the admin settings and such
add_action('admin_init', 'awdcsv_admin_init');
function awdcsv_admin_init(){
	register_setting( 'awdcsv_options', 'awdcsv_options', 'awdcsv_options_validate' );
	add_settings_section('awdcsv_main', 'Main Settings', 'awdcsv_section_text', 'awdcsv');
	add_settings_field('csv_url', 'CSV Import URL', 'awdcsv_setting_csv_url', 'awdcsv', 'awdcsv_main');
	add_settings_section('awdcsv_headers', 'Import Settings', 'awdcsv_headerimport_text', 'awdcsv');
	add_settings_field('headers', 'Headers', 'awdcsv_setting_headers', 'awdcsv', 'awdcsv_headers');
	add_settings_field('import', 'Import', 'awdcsv_setting_import', 'awdcsv', 'awdcsv_headers');
}

function awdcsv_section_text() {
	echo '<p>Update the AWD Datafeedr CSV Import and Search Settings here.</p>';
} 
function awdcsv_headerimport_text() {
	echo '<p>Choose your CSV file above, Save Settings and the headers from your CSV will appear here. You then need to assign the headers from your file to those required for the import to Datafeedr.</p>';
} 

function awdcsv_setting_csv_url() {
	$options = get_option('awdcsv_options');
	echo "<input id='awdcsv_csv' name='awdcsv_options[csv_string]' size='40' type='text' value='{$options['csv_string']}' />";
}
function awdcsv_setting_listing_category_name() {
	$options = get_option('awdcsv_options');
	echo "<p>Enter the wordpress 'post category name' you would like to import vehicles to or enter the word 'automotiv' if you are using the Automotiv theme</p>";
	echo "<input class='awdwpspecificsetting' id='awdcsv_categoryname' name='awdcsv_options[categoryname]' size='40' type='text' value='{$options['categoryname']}' />";
	
}
function awdcsv_setting_listing_permalink() {
	$options = get_option('awdcsv_options');
	echo "<input class='awdwpspecificsetting' id='awdcsv_permalink' name='awdcsv_options[searchpermalink]' size='40' type='text' value='{$options['searchpermalink']}' />";
}
function awdcsv_setting_headers() {
	$options = get_option('awdcsv_options');

	//1. populate headers on page so user can configure
	echo "<h3>Headers from csv</h3>";
	$headers = awdimportheaders();
	
	echo "<textarea rows=10 cols=80>" . implode(',', $headers) . "</textarea>";
	//2. record each header mapping as an array inside this array?
	//3. then add import button
	echo "<div style='clear:left'></div>";
	echo $options['headers']['merchant'];
	echo "Merchant Name: <input name='awdcsv_options[merchant]' size=40 type='text' value='{$options['headers']['merchant']}' /><br />";
	echo "Merchant Logo: <input name='awdcsv_options[merchantlogo]' size=40 type='text' value='{$options['headers']['merchantlogo']}' /><br />";
	echo "Product Name: <input name='awdcsv_options[name]' size=40 type='text' value='{$options['headers']['name']}' /><br />";
	echo "Product Slug: <input name='awdcsv_options[slug]' size=40 type='text' value='{$options['headers']['slug']}' /><br />";
	echo "Description: <input name='awdcsv_options[description]' size=40 type='text' value='{$options['headers']['description']}' /><br />";
	echo "Price: <input name='awdcsv_options[price]' size=40 type='text' value='{$options['headers']['price']}' /><br />";
	echo "Image: <input name='awdcsv_options[image]' size=40 type='text' value='{$options['headers']['image']}' /><br />";
	echo "Thumbnail: <input name='awdcsv_options[thumbnail]' size=40 type='text' value='{$options['headers']['thumbnail']}' /><br />";
	echo "Exit URL: <input name='awdcsv_options[url]' size=40 type='text' value='{$options['headers']['url']}' /><br />";
	echo "Tags: <input name='awdcsv_options[tags]' size=40 type='text' value='{$options['headers']['tags']}' /><br />";
	echo "SalePrice: <input name='awdcsv_options[saleprice]' size=40 type='text' value='{$options['headers']['saleprice']}' /><br />";
	echo "Brand: <input name='awdcsv_options[brand]' size=40 type='text' value='{$options['headers']['brand']}' /><br />";
	echo "Currency: <input name='awdcsv_options[currency]' size=40 type='text' value='{$options['headers']['currency']}' /><br />";
	echo "Ship Price: <input name='awdcsv_options[shipprice]' size=40 type='text' value='{$options['headers']['shipprice']}' /><br />";
	echo "Displayed Price: <input name='awdcsv_options[sprice]' size=40 type='text' value='{$options['headers']['sprice']}' /><br />";
	echo "Promo: <input name='awdcsv_options[promo]' size=40 type='text' value='{$options['headers']['promo']}' /><br />";
	echo "Specs: <input name='awdcsv_options[specs]' size=40 type='text' value='{$options['headers']['specs']}' /><br />";
	echo "Site Link (store+'/'+slug): <input name='awdcsv_options[site_link]' size=40 type='text' value='{$options['headers']['site_link']}' /><br />";
	echo "Category ID: <input name='awdcsv_options[cat_id]' size=40 type='text' value='{$options['headers']['cat_id']}' /><br />";
	
	echo '<a href="?importnow=1">Import Now</a>';
}
function awdcsv_setting_import() {
	$options = get_option('awdcsv_options');

	if ($_GET['importnow'] == '1') {
		echo "<h2>Importing Products</h2>";
		$options['importnow'] = '';
		awdimportcsv();	
	}
}
	
// validate our options
function awdcsv_options_validate($input) {
	$options = get_option('awdcsv_options');
	$options['csv_string'] = trim($input['csv_string']);
	$options['headers']['merchant'] = trim($input['merchant']);
	$options['headers']['merchantlogo'] = trim($input['merchantlogo']);
	$options['headers']['name'] = trim($input['name']);
	$options['headers']['slug'] = trim($input['slug']);
	$options['headers']['description'] = trim($input['description']);
	$options['headers']['price'] = trim($input['price']);
	$options['headers']['image'] = trim($input['image']);
	$options['headers']['thumbnail'] = trim($input['thumbnail']);
	$options['headers']['url'] = trim($input['url']);
	$options['headers']['tags'] = trim($input['tags']);
	$options['headers']['saleprice'] = trim($input['saleprice']);
	$options['headers']['brand'] = trim($input['brand']);
	$options['headers']['currency'] = trim($input['currency']);
	$options['headers']['shipprice'] = trim($input['shipprice']);
	$options['headers']['sprice'] = trim($input['sprice']);
	$options['headers']['promo'] = trim($input['promo']);
	$options['headers']['specs'] = trim($input['specs']);
	$options['headers']['site_link'] = trim($input['site_link']);
	$options['headers']['cat_id'] = trim($input['cat_id']);

	$options['importnow'] = trim($input['importnow']);

	/*	if(!preg_match('/^[a-z0-9]{32}$/i', $options['text_string'])) {
		$options['text_string'] = '';
	}
*/
	return $options;
}

function awdimportheaders() {
	$options = get_option('awdcsv_options');

	//$url = "http://www.lotbot.com/cargigi/35818.csv"; // csv file to import
	$url = $options['csv_string']; // csv file to import

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	if( ! $tmp = curl_exec($ch))
	{
	   echo curl_error($ch);
	   return '';
	} 
	$tmp = str_replace("\t", ",", $tmp);

	$vehicles = explode("\n", $tmp);
	foreach($vehicles as $vehiclerow) {
		$header = str_getcsv(str_replace(" ", "", strtolower($vehiclerow)));		
		break;
	}

	curl_close($ch);
	return $header;
}
function awdimportcsv() {
	global $wpdb;
	$options = get_option('awdcsv_options');

	
	//$url = "http://www.lotbot.com/cargigi/35818.csv"; // csv file to import
	$url = $options['csv_string']; // csv file to import

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	if( ! $tmp = curl_exec($ch))
	{
	   echo curl_error($ch);
	   die;
	} 
	$tmp = str_replace("\t", ",", $tmp);

	$vehicles = explode("\n", $tmp);
	$v = array();
	$first = true;
	$vehiclesimported = 0;
	foreach($vehicles as $vehiclerow) {
		if($first)
		{
			$header = str_getcsv(str_replace(" ", "", strtolower($vehiclerow)));		
			$first=false;
			continue;
		} 
		else {
			$vehiclesimported++;
		}
		$v[] = array_combine($header, str_getcsv($vehiclerow));
	}
	curl_close($ch);

	// staging data now in standard array - if loading different set of data, map it using different $header above but get it into same array


	foreach ($v as $vehicle) {
		//todo: for each row, insert to wp_dfr_shop_products

		echo $vehicle[$options['headers']['merchant']] . "<br />";
		echo $vehicle[$options['headers']['merchantlogo']] . "<br />";
		echo $vehicle[$options['headers']['name']] . "<br />";
		echo $vehicle[$options['headers']['slug']] . "<br />";
		echo $vehicle[$options['headers']['description']] . "<br />";
		echo $vehicle[$options['headers']['price']] . "<br />";
		echo $vehicle[$options['headers']['image']] . "<br />";
		echo $vehicle[$options['headers']['thumbnail']] . "<br />";
		echo $vehicle[$options['headers']['url']] . "<br />";
		echo $vehicle[$options['headers']['tags']] . "<br />";
		echo $vehicle[$options['headers']['saleprice']] . "<br />";
		echo $vehicle[$options['headers']['brand']] . "<br />";
		echo $vehicle[$options['headers']['currency']] . "<br />";
		echo $vehicle[$options['headers']['shipprice']] . "<br />";
		echo $vehicle[$options['headers']['promo']] . "<br />";
		echo $vehicle[$options['headers']['specs']] . "<br />";
		echo $vehicle[$options['headers']['site_link']] . "<br />";
		echo $vehicle[$options['headers']['cat_id']] . "<br />";

		$rownum_row = $wpdb->get_row("SELECT max(id) as id FROM " . $wpdb->prefix . "dfr_shop_products");
		$rownum = $rownum_row->id + 1;
		
		try {
			echo "inserting....";
			
			//todo: if merchantname does not yet exist, add it to merchants table
			// else pick up merchantid from merchants table for this merchant name
			$merchantid = 0;
			$merchantrow = $wpdb->get_row(
				$wpdb->prepare(
					"SELECT id FROM " . $wpdb->prefix . "dfr_shop_merchants where name = '%s'",
					$vehicle[$options['headers']['merchant']]
				));
				
			if ($wpdb->num_rows == 0) {
				// insert a row			
				// first grab largest merchantid
				$merchantmaxrow = $wpdb->get_row("SELECT max(id) as id FROM " . $wpdb->prefix . "dfr_shop_merchants");
				if ($wpdb->num_rows == 0 || $merchantmaxrow < 10000) {
					$merchantid = 10000;
				} else {
					$merchantid = $merchantmaxrow->id;
				}
				$merchantid = $merchantid + 1;

				$wpdb->insert($wpdb->prefix . 'dfr_shop_merchants',
					array (
						'id' => $merchantid,
						'name' => $vehicle[$options['headers']['merchant']],
						'logo' => $vehicle[$options['headers']['merchantlogo']]
					)
				);

			}
			else {
				$merchantid = $merchantrow->id;
			}
				

			
			
			$wpdb->insert( 
				$wpdb->prefix . 'dfr_shop_products', 
				array( 
					'id' => $rownum,
					'merchant' => $vehicle[$options['headers']['merchant']], 
					'merchant_id' => $merchantid, 
					'name' => $vehicle[$options['headers']['name']],
					'slug' => $vehicle[$options['headers']['slug']],
					'description' => $vehicle[$options['headers']['description']],
					'price' => $vehicle[$options['headers']['price']],
					'image' => $vehicle[$options['headers']['image']],
					'thumbnail' => $vehicle[$options['headers']['thumbnail']],
					'url' => $vehicle[$options['headers']['url']],
					'tags' => $vehicle[$options['headers']['tags']],
					'saleprice' => $vehicle[$options['headers']['saleprice']],
					'brand' => $vehicle[$options['headers']['brand']],
					'currency' => $vehicle[$options['headers']['currency']],
					'shipprice' => $vehicle[$options['headers']['shipprice']],
					'promo' => $vehicle[$options['headers']['promo']],
					'specs' => $vehicle[$options['headers']['specs']],
					'site_link' => $vehicle[$options['headers']['site_link']],
					'name' => $vehicle[$options['headers']['name']],
					'cat_id' => $vehicle[$options['headers']['cat_id']]
				) 
			);
			$rownum = $rownum + 1;
		}
		catch(Exception $e) {
			echo $e->getMessage();
		}
		
	}		
}
?>
